Given an array of integers arr
, you are initially positioned at the first index of the array.
In one step you can jump from index i
to index:
i + 1
where:i + 1 < arr.length
.i - 1
where:i - 1 >= 0
.j
where:arr[i] == arr[j]
andi != j
.
Return the minimum number of steps to reach the last index of the array.
Notice that you can not jump outside of the array at any time.
Example 1:
Input: arr = [100,-23,-23,404,100,23,23,23,3,404] Output: 3 Explanation: You need three jumps from index 0 --> 4 --> 3 --> 9. Note that index 9 is the last index of the array.
Example 2:
Input: arr = [7] Output: 0 Explanation: Start index is the last index. You do not need to jump.
Example 3:
Input: arr = [7,6,9,6,9,6,9,7] Output: 1 Explanation: You can jump directly from index 0 to index 7 which is last index of the array.
Constraints:
1 <= arr.length <= 5 * 104
-108 <= arr[i] <= 108
Related Topics:
Array, Hash Table, Breadth-First Search
Similar Questions:
Since we are looking for the shortest distance, BFS should be our first option.
// OJ: https://leetcode.com/problems/jump-game-iv/
// Author: github.com/lzl124631x
// Time: O(N)
// Space: O(N)
class Solution {
public:
int minJumps(vector<int>& A) {
unordered_map<int, vector<int>> m;
int N = A.size(), step = 0;
for (int i = 0; i < N; ++i) m[A[i]].push_back(i);
vector<bool> seen(N);
seen[0] = true;
queue<int> q{{0}};
while (q.size()) {
int cnt = q.size();
while (cnt--) {
int u = q.front();
q.pop();
if (u == N - 1) return step;
if (u - 1 >= 0 && !seen[u - 1]) {
q.push(u - 1);
seen[u - 1] = true;
}
if (u + 1 < N && !seen[u + 1]) {
q.push(u + 1);
seen[u + 1] = true;
}
if (m.count(A[u])) {
for (int v : m[A[u]]) {
if (seen[v]) continue;
seen[v] = true;
q.push(v);
}
m.erase(A[u]);
}
}
++step;
}
return -1;
}
};